open Specification
open Datatypes
open Flatten
open InSig
open EqNat
open List0
open MinMax
open Option
open Peano
open NPeano
open Peano_dec
open Heat1D
open NatTools
open BsmlNat.Primitives
(* open Bsml ;; *)
(* open Stdlib.Base ;; *)
(* open Stdlib.Comm;; *)
(* open Tools ;; *)
(* open NatTools ;; *)
(* open Specification ;; *)
(* open Datatypes ;; *)
open Benchmarking ;;

module Processors = 
struct 
  type __ = Obj.t
  let __ = let rec f _ = Obj.repr f in Obj.repr f
  let max_pid =  nat_of_int  (Bsml.bsp_p - 1)
  let firstProcessor = nat_of_int 0
  let lastProcessor = nat_of_int (Bsml.bsp_p - 1)
  let processorOfNatMod n = modulo n (nat_of_int Bsml.bsp_p)
  let natOfProcessor p =p
  let processorOfNat i = i
  let processorEqDec p1 p2 = eq_nat_dec p1 p2
  let processor_beq p1 p2 = eq_nat_dec p1 p2
  let processors = List.map nat_of_int (Tools.from_to 0 (Bsml.bsp_p-1))
  let processorsUpTo i = List.map nat_of_int (Tools.from_to 0 (int_of_nat i))
  let processorsStartingAt i =  List.map nat_of_int (Tools.from_to (int_of_nat i) (Bsml.bsp_p-1))
  
  let processorsRevInduction_obligation_2 x x0 =
    let rec f n x1 =
      match n with
      | O -> x1
      | S n0 -> let sp = S n0 in f n0 (x n0 sp __ __ x1)
    in f lastProcessor x0
  let processorsRevInduction x x0 =
    processorsRevInduction_obligation_2 x x0

  let listOfParList plst =  failwith "listOfParList is for Specification purpose only" 
end

module ParSig = 
struct
  let parSig v = v 
  let parInSig lv = lv 
end

module Base = Base.Make(BsmlNat.Primitives)(Processors)(ParSig)
module Comm = Comm.Make(BsmlNat.Primitives)(Processors)(ParSig)(Base)

module BenchNat = Bench.Coq_bench(BsmlNat.Primitives)(Processors)(ParSig)(Base)(Comm)

let coq_generator x =  float_of_int (Random.int 1000)
let direct_generator x =  float_of_int (Random.int 1000)

  let _ =  
      Benchmarking.program_name:="shift";
      benchmarking   (fun s d -> BenchNat.shift d) coq_generator  (fun s d ->   Stdlib.Comm.shift_left d)  direct_generator  (fun s d -> BenchNat.shift d)
