open Datatypes
open EqNat
open List0
open MinMax
open Option
open Peano
open Specification

type __ = Obj.t

module type TYPE = 
 functor (BsmlPrimitives:PRIMITIVES) ->
 functor (BsmlPropertiesM:sig 
  val max_pid : nat
  
  val firstProcessor : BsmlPrimitives.processor
  
  val lastProcessor : BsmlPrimitives.processor
  
  val processorOfNatMod : nat -> BsmlPrimitives.processor
  
  val processorEqDec :
    BsmlPrimitives.processor -> BsmlPrimitives.processor -> bool
  
  val processor_beq :
    BsmlPrimitives.processor -> BsmlPrimitives.processor -> bool
  
  val processors : BsmlPrimitives.processor list
  
  val processorsUpTo :
    BsmlPrimitives.processor -> BsmlPrimitives.processor list
  
  val processorsStartingAt :
    BsmlPrimitives.processor -> BsmlPrimitives.processor list
  
  val processorsRevInduction_obligation_2 :
    (BsmlPrimitives.processor -> BsmlPrimitives.processor -> __ -> __ -> 'a1
    -> 'a1) -> 'a1 -> 'a1
  
  val processorsRevInduction :
    (BsmlPrimitives.processor -> BsmlPrimitives.processor -> __ -> __ -> 'a1
    -> 'a1) -> 'a1 -> 'a1
  
  val listOfParList : 'a1 list BsmlPrimitives.par -> 'a1 list
 end) ->
 functor (ParSigM:sig 
  val parSig : 'a1 BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val parInSig : 'a1 list BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
 end) ->
 functor (BsmlBaseM:sig 
  val replicate : 'a1 -> 'a1 BsmlPrimitives.par
  
  val parfun :
    ('a1 -> 'a2) -> 'a1 BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val parfun2 :
    ('a1 -> 'a2 -> 'a3) -> 'a1 BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
    -> 'a3 BsmlPrimitives.par
  
  val mask :
    (BsmlPrimitives.processor -> bool) -> 'a1 BsmlPrimitives.par -> 'a1
    BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val parfunif :
    (BsmlPrimitives.processor -> bool) -> ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1
    BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val applyif :
    (BsmlPrimitives.processor -> bool) -> ('a1 -> 'a2) BsmlPrimitives.par ->
    ('a1 -> 'a2) BsmlPrimitives.par -> 'a1 BsmlPrimitives.par -> 'a2
    BsmlPrimitives.par
  
  val parfunat :
    BsmlPrimitives.processor -> ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1
    BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val applyat :
    BsmlPrimitives.processor -> ('a1 -> 'a2) BsmlPrimitives.par -> ('a1 ->
    'a2) BsmlPrimitives.par -> 'a1 BsmlPrimitives.par -> 'a2
    BsmlPrimitives.par
  
  val this : BsmlPrimitives.processor BsmlPrimitives.par
  
  val procs : BsmlPrimitives.processor list
  
  val get_one_aux :
    'a1 BsmlPrimitives.par -> nat BsmlPrimitives.par -> 'a1 option
    BsmlPrimitives.par
  
  val get_one :
    'a1 BsmlPrimitives.par -> nat BsmlPrimitives.par -> 'a1
    BsmlPrimitives.par
  
  val get_list_aux :
    'a1 BsmlPrimitives.par -> nat list BsmlPrimitives.par -> 'a1 option list
    BsmlPrimitives.par
  
  val get_list :
    'a1 BsmlPrimitives.par -> nat list BsmlPrimitives.par -> 'a1 list
    BsmlPrimitives.par
  
  val put_one :
    (nat, 'a1) prod BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
  
  val put_list :
    (nat, 'a1) prod list BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
 end) ->
 sig 
  val heatEquationFormula :
    float -> float -> float -> float ->
    float -> float -> float
  
  val heatEquationSeq :
    float -> float -> float -> float ->
    float -> float list -> float list
  
  val projPar : 'a1 BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val strongHead : 'a1 list -> 'a1
  
  val sHead : 'a1 list -> 'a1
  
  val last_error : 'a1 list -> 'a1 option
  
  val strongLast : 'a1 list -> 'a1
  
  val sLast : 'a1 list -> 'a1
  
  val constantFunPar : 'a2 -> ('a1 -> 'a2) BsmlPrimitives.par
  
  val getBoundsAux :
    'a1 -> 'a1 -> 'a1 list BsmlPrimitives.par -> ('a1 option
    BsmlPrimitives.par, 'a1 option BsmlPrimitives.par) prod
  
  val getBounds :
    'a1 -> 'a1 -> 'a1 list BsmlPrimitives.par -> ('a1 BsmlPrimitives.par, 'a1
    BsmlPrimitives.par) prod
  
  val heatEquationPar :
    float -> float -> float -> float ->
    float -> float list BsmlPrimitives.par -> float
    list BsmlPrimitives.par
  
  val rightBoundAtI :
    float -> float list BsmlPrimitives.par ->
    BsmlPrimitives.processor -> float
  
  val leftBoundAtI :
    float -> float list BsmlPrimitives.par ->
    BsmlPrimitives.processor -> float
 end

module Make = 
 functor (BsmlPrimitives:PRIMITIVES) ->
 functor (BsmlPropertiesM:sig 
  val max_pid : nat
  
  val firstProcessor : BsmlPrimitives.processor
  
  val lastProcessor : BsmlPrimitives.processor
  
  val processorOfNatMod : nat -> BsmlPrimitives.processor
  
  val processorEqDec :
    BsmlPrimitives.processor -> BsmlPrimitives.processor -> bool
  
  val processor_beq :
    BsmlPrimitives.processor -> BsmlPrimitives.processor -> bool
  
  val processors : BsmlPrimitives.processor list
  
  val processorsUpTo :
    BsmlPrimitives.processor -> BsmlPrimitives.processor list
  
  val processorsStartingAt :
    BsmlPrimitives.processor -> BsmlPrimitives.processor list
  
  val processorsRevInduction_obligation_2 :
    (BsmlPrimitives.processor -> BsmlPrimitives.processor -> __ -> __ -> 'a1
    -> 'a1) -> 'a1 -> 'a1
  
  val processorsRevInduction :
    (BsmlPrimitives.processor -> BsmlPrimitives.processor -> __ -> __ -> 'a1
    -> 'a1) -> 'a1 -> 'a1
  
  val listOfParList : 'a1 list BsmlPrimitives.par -> 'a1 list
 end) ->
 functor (ParSigM:sig 
  val parSig : 'a1 BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val parInSig : 'a1 list BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
 end) ->
 functor (BsmlBaseM:sig 
  val replicate : 'a1 -> 'a1 BsmlPrimitives.par
  
  val parfun :
    ('a1 -> 'a2) -> 'a1 BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val parfun2 :
    ('a1 -> 'a2 -> 'a3) -> 'a1 BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
    -> 'a3 BsmlPrimitives.par
  
  val mask :
    (BsmlPrimitives.processor -> bool) -> 'a1 BsmlPrimitives.par -> 'a1
    BsmlPrimitives.par -> 'a1 BsmlPrimitives.par
  
  val parfunif :
    (BsmlPrimitives.processor -> bool) -> ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1
    BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val applyif :
    (BsmlPrimitives.processor -> bool) -> ('a1 -> 'a2) BsmlPrimitives.par ->
    ('a1 -> 'a2) BsmlPrimitives.par -> 'a1 BsmlPrimitives.par -> 'a2
    BsmlPrimitives.par
  
  val parfunat :
    BsmlPrimitives.processor -> ('a1 -> 'a2) -> ('a1 -> 'a2) -> 'a1
    BsmlPrimitives.par -> 'a2 BsmlPrimitives.par
  
  val applyat :
    BsmlPrimitives.processor -> ('a1 -> 'a2) BsmlPrimitives.par -> ('a1 ->
    'a2) BsmlPrimitives.par -> 'a1 BsmlPrimitives.par -> 'a2
    BsmlPrimitives.par
  
  val this : BsmlPrimitives.processor BsmlPrimitives.par
  
  val procs : BsmlPrimitives.processor list
  
  val get_one_aux :
    'a1 BsmlPrimitives.par -> nat BsmlPrimitives.par -> 'a1 option
    BsmlPrimitives.par
  
  val get_one :
    'a1 BsmlPrimitives.par -> nat BsmlPrimitives.par -> 'a1
    BsmlPrimitives.par
  
  val get_list_aux :
    'a1 BsmlPrimitives.par -> nat list BsmlPrimitives.par -> 'a1 option list
    BsmlPrimitives.par
  
  val get_list :
    'a1 BsmlPrimitives.par -> nat list BsmlPrimitives.par -> 'a1 list
    BsmlPrimitives.par
  
  val put_one :
    (nat, 'a1) prod BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
  
  val put_list :
    (nat, 'a1) prod list BsmlPrimitives.par -> 'a1 list BsmlPrimitives.par
 end) ->
 struct 
  (** val heatEquationFormula :
      float -> float -> float -> float ->
      float -> float -> float **)
  
  let heatEquationFormula dt dx gamma uI uIMinusOne uIPlusOne =
    
      (( (gamma *. dt) /. (dx *. dx)) *.
        (((uIPlusOne +. uIMinusOne) -. uI) -. uI)) +. uI
  
  (** val heatEquationSeq :
      float -> float -> float -> float ->
      float -> float list -> float list **)
  
  let rec heatEquationSeq leftBound rightBound dt dx gamma = function
  | [] -> []
  | uI::u' ->
    (match u' with
     | [] -> (heatEquationFormula dt dx gamma uI leftBound rightBound)::[]
     | uIPlusOne::l ->
       (heatEquationFormula dt dx gamma uI leftBound uIPlusOne)::(heatEquationSeq
                                                                   uI
                                                                   rightBound
                                                                   dt dx
                                                                   gamma u'))
  
  (** val projPar : 'a1 BsmlPrimitives.par -> 'a1 BsmlPrimitives.par **)
  
  let projPar v =
    BsmlBaseM.parfun (fun e -> e) v
  
  (** val strongHead : 'a1 list -> 'a1 **)
  
  let strongHead l =
    noSome (hd_error l)
  
  (** val sHead : 'a1 list -> 'a1 **)
  
  let sHead l =
    strongHead l
  
  (** val last_error : 'a1 list -> 'a1 option **)
  
  let rec last_error = function
  | [] -> None
  | x::xs ->
    (match xs with
     | [] -> Some x
     | a::l0 -> last_error xs)
  
  (** val strongLast : 'a1 list -> 'a1 **)
  
  let strongLast l =
    noSome (last_error l)
  
  (** val sLast : 'a1 list -> 'a1 **)
  
  let sLast l =
    strongLast l
  
  (** val constantFunPar : 'a2 -> ('a1 -> 'a2) BsmlPrimitives.par **)
  
  let constantFunPar b =
    BsmlPrimitives.mkpar (fun pid a -> b)
  
  (** val getBoundsAux :
      'a1 -> 'a1 -> 'a1 list BsmlPrimitives.par -> ('a1 option
      BsmlPrimitives.par, 'a1 option BsmlPrimitives.par) prod **)
  
  let getBoundsAux leftBound rightBound v =
    let msg =
      BsmlPrimitives.put
        (BsmlPrimitives.apply
          (BsmlPrimitives.mkpar (fun pid data dst ->
            if if beq_nat dst (plus pid (S O))
               then negb (beq_nat pid (minus BsmlPrimitives.bsp_p (S O)))
               else false
            then Some (sLast data)
            else if if beq_nat dst (minus pid (S O))
                    then negb (beq_nat pid O)
                    else false
                 then Some (sHead data)
                 else None)) (ParSigM.parSig v))
    in
    Coq_pair
    ((BsmlBaseM.applyat BsmlPropertiesM.firstProcessor
       (constantFunPar (Some leftBound)) msg
       (ParSigM.parSig (BsmlPrimitives.mkpar (fun pid -> minus pid (S O))))),
    (BsmlBaseM.applyat BsmlPropertiesM.lastProcessor
      (constantFunPar (Some rightBound)) msg
      (ParSigM.parSig
        (BsmlPrimitives.mkpar (fun pid ->
          min (plus pid (S O)) BsmlPropertiesM.lastProcessor)))))
  
  (** val getBounds :
      'a1 -> 'a1 -> 'a1 list BsmlPrimitives.par -> ('a1 BsmlPrimitives.par,
      'a1 BsmlPrimitives.par) prod **)
  
  let getBounds leftBound rightBound v =
    let tmp = getBoundsAux leftBound rightBound v in
    Coq_pair
    ((BsmlBaseM.parfun (fun x -> noSome x)
       (ParSigM.parSig (fst (Coq_pair ((fst tmp), (snd tmp)))))),
    (BsmlBaseM.parfun (fun x -> noSome x)
      (ParSigM.parSig (snd (Coq_pair ((fst tmp), (snd tmp)))))))
  
  (** val heatEquationPar :
      float -> float -> float -> float ->
      float -> float list BsmlPrimitives.par -> float
      list BsmlPrimitives.par **)
  
  let heatEquationPar leftBound rightBound dt dx gamma u =
    let bounds = getBounds leftBound rightBound u in
    BsmlPrimitives.apply
      (BsmlBaseM.parfun2 (fun l r -> heatEquationSeq l r dt dx gamma)
        (fst (Coq_pair ((fst bounds), (snd bounds))))
        (snd (Coq_pair ((fst bounds), (snd bounds))))) u
  
  (** val rightBoundAtI :
      float -> float list BsmlPrimitives.par ->
      BsmlPrimitives.processor -> float **)
  
  let rightBoundAtI rightBound u i =
    if beq_nat i BsmlPropertiesM.lastProcessor
    then rightBound
    else sHead
           (BsmlPrimitives.get u
             (min (plus i (S O)) BsmlPropertiesM.lastProcessor))
  
  (** val leftBoundAtI :
      float -> float list BsmlPrimitives.par ->
      BsmlPrimitives.processor -> float **)
  
  let leftBoundAtI leftBound u i =
    if beq_nat i BsmlPropertiesM.firstProcessor
    then leftBound
    else sLast (BsmlPrimitives.get u (minus i (S O)))
 end

