Require Export Coq.Arith.Min.
Require Import Arith.
Require Import Omega.

(** [min x y] can be written [x - (x - y)] as we compute over natural numbers *)
Lemma min_minus x y: min x y = x - (x - y).
Proof.
  intros. generalize x.
  induction y.
  intro. destruct x0. auto. simpl. apply minus_n_n.
  intro. destruct x0. simpl. reflexivity.
  change (S x0 - S y) with (x0 - y).
  rewrite <- minus_Sn_m.
  simpl min. f_equal.
  apply IHy.
  omega.
Qed.
Implicit Arguments min_minus [ x y].

Lemma lt_min : forall n m m', n < min m m' -> n< m /\ n< m'.
Proof. 
  intros n m m' H.
  split;   rewrite min_minus in H;  omega.
Qed.
Implicit Arguments lt_min [ n m m'].
