Require Import LIFO.Vector.Vector.

(** * Facts about [app] *)

Lemma app_cons: 
  forall (A:Type)  n (v:vector A n)(a:A), 
    Vcons a v = (Vcons a Vnil) ++ v.
Proof.
  intros A n v.
  induction v. 
  reflexivity.
  rewrite IHv. reflexivity.
Qed.

Lemma in_app_or  : forall (A : Type)  n (v : vector A n) n' (v' :vector A n') (a : A),
       In a (v ++ v') -> In a v \/ In a v'
.
Proof.
  intros A n v n' v' a H.
  induction v.
  simpl in *.
  right; assumption.
  simpl in *.
destruct H.
left;left ;assumption.
destruct (IHv H).
left;right;assumption.
right;assumption.
Qed.

Lemma in_or_app  : forall (A : Type)  n (v : vector A n) n' (v' :vector A n') (a : A),
       In a v \/ In a v'-> In a (v ++ v') 
.
Proof.
  intros A n v n' v' a H.
  induction v.
  simpl in *. destruct H.
  elim H.   assumption.
  simpl in *.
  destruct H as [[aa0 | in_v]  |in_v'].
left ;assumption.
right.
apply (IHv).
left;assumption.
right;apply (IHv); right;assumption.
Qed.

Lemma in_app_iff : forall (A : Type)  n (v : vector A n) n' (v' :vector A n') (a : A),
  In a (v ++ v') <-> In a v \/ In a v'.
Proof.
  intros A n v n' v' a.
  split.
  apply in_app_or.  apply in_or_app.
Qed.
(* (* To be removed, is solve by firstorder *) *)
(* Lemma inAppCons: *)
(*   forall (A:Type)(l1 l2:list A)(a:A), *)
(*     In a (l1++a::l2). *)
(* Proof. *)
(*   intros A l1 l2 a. *)
(*   apply in_app_iff; right; simpl; left; reflexivity. *)
(* Qed. *)


  
(* Lemma app_l_l'_nil : forall A (l l' : list A), l = l++l' -> l'=nil. *)
(*   intros A. *)
(*   induction l. intros; simpl in H; symmetry; auto. *)
(*   intros. *)
(*   simpl in H. injection H. intro H'; rewrite <- H' in *. apply IHl. assumption. *)
(* Qed. *)
