 Unset Automatic Introduction.    (* coq 8.3_rc1 *)
(** A module of bounded naturals *)

Require Import Arith.
Require Import LIFO.Nat.ProofEquality.
(* Require Import Eqdep_dec. *)
(* Require Import Peano_dec. *)



(* (** * Axiom K is provable for [nat] *) *)

(* Theorem K_nat : *)
(*   forall (x:nat) (P:x = x -> Prop), P (refl_equal x) -> forall p:x = x, P p. *)
(* Proof. *)
(*   intros; apply K_dec_set with (p := p). *)
(*   apply eq_nat_dec. *)
(*   assumption. *)
(* Qed. *)

(* Theorem eq_rect_eq_nat : *)
(*   forall (p:nat) (Q:nat->Type) (x:Q p) (h:p=p), x = eq_rect p Q x p h. *)
(* Proof. *)
(*   intros; apply K_nat with (p := h); reflexivity. *)
(* Qed.  *)

(* Scheme leInductionPrinciple := Induction for le Sort Prop. *)
(* (** * Two proofs of [n<m] are equals *) *)

(* Theorem ltUniquenessProof  *)
(*   (n m : nat) (H1 H2 : n < m) :  *)
(*   H1 = H2. *)
(* Proof.  *)
(*   unfold lt; induction H1 using leInductionPrinciple; intro H2. *)
(*     replace (le_n (S n)) with *)
(*       (eq_rect _ (fun n0 => S n <= n0) (le_n (S n)) _ (refl_equal (S n))). *)
(*       generalize (refl_equal(S n)). *)
(*       pattern (S n) at 2 4 6 10, H2; case H2; [intro | intros m l e]. *)
(*       rewrite <- eq_rect_eq_nat; trivial. *)
(*       contradiction (le_Sn_n m); rewrite <- e; assumption. *)
(*       reflexivity. *)
(*     replace (le_S (S n) m H1) with *)
(*       (eq_rect _ (fun n0 => S n <= n0) (le_S (S n) m H1) _ (refl_equal (S m))). *)
(*       generalize (refl_equal (S m)). *)
(*       pattern (S m) at 1 3 4 6, H2; case H2; [intro Heq | intros m0 l HeqS]. *)
(*       contradiction (le_Sn_n m); rewrite Heq; assumption. *)
(*       injection HeqS; intro Heq; generalize l HeqS. *)
(*       rewrite <- Heq; intros; rewrite <- eq_rect_eq_nat. *)
(*       rewrite (IHle l0); reflexivity. *)
(*       reflexivity. *)
(* Qed. *)

(* Theorem leUniquenessProof   *)
(*   (n m : nat) (H1 H2 : n <= m) :  *)
(*   H1 = H2. *)
(* Proof. *)
(*   unfold lt; induction H1 using leInductionPrinciple; intro H2. *)
(*     replace (le_n (n)) with *)
(*       (eq_rect _ (fun n0 => n <= n0) (le_n (n)) _ (refl_equal (n))). *)
(*       generalize (refl_equal(n)). *)
(*       pattern (n) at 2 4 6 10, H2; case H2; [intro | intros m l e]. *)
(*       rewrite <- eq_rect_eq_nat; trivial. *)
(*       contradiction (le_Sn_n m); rewrite <- e; assumption. *)
(*       reflexivity. *)
(*     replace (le_S (n) m H1) with *)
(*       (eq_rect _ (fun n0 => n <= n0) (le_S (n) m H1) _ (refl_equal (S m))). *)
(*       generalize (refl_equal (S m)). *)
(*       pattern (S m) at 1 3 4 6, H2; case H2; [intro Heq | intros m0 l HeqS]. *)
(*       contradiction (le_Sn_n m); rewrite Heq; assumption. *)
(*       injection HeqS; intro Heq; generalize l HeqS. *)
(*       rewrite <- Heq; intros; rewrite <- eq_rect_eq_nat. *)
(*       rewrite (IHle l0); reflexivity. *)
(*       reflexivity. *)
(* Qed. *)


(** * The type of bounded naturals *)

Definition boundedNat (bound:nat):= { n:nat | n<bound }.

(** projT1 is injective for bounded naturals. *)

(* TODO: Use the class "Injective" *)

Lemma projT1BoundedNatInjective:
  forall
   (bound:nat)(bn1 bn2 : boundedNat bound),
    projT1 bn1 = projT1 bn2 ->
    bn1 = bn2.
Proof.
  intros bound bn1 bn2 H.
  destruct bn1 ; destruct bn2 ; simpl in *.
  revert l l0 ; rewrite H ; intros l l0.
  rewrite ltUniquenessProof with (n:=x0)(m:=bound)(H1:=l)(H2:=l0).
  reflexivity.
Qed.

Lemma projT1BoundedNat : 
  forall (bound : nat) (bn1 bn2 : boundedNat bound), 
    bn1 = bn2 -> projT1 bn1 = projT1 bn2.
Proof.
intros.
rewrite H.
reflexivity.
Qed.

Lemma proj1_sigBoundedNatInjective:
  forall
    (bound:nat)(bn1 bn2 : boundedNat bound),
    proj1_sig bn1 = proj1_sig bn2 ->
    bn1 = bn2.
Proof.
  intros bound bn1 bn2 H.
  destruct bn1 ; destruct bn2 ; simpl in *.
  revert l l0 ; rewrite H ; intros l l0.
  rewrite ltUniquenessProof with (n:=x0)(m:=bound)(H1:=l)(H2:=l0).
  reflexivity.
Qed.

Lemma proj1_sigBoundedNat : 
  forall (bound : nat) (bn1 bn2 : boundedNat bound), 
    bn1 = bn2 -> proj1_sig bn1 = proj1_sig bn2.
Proof.
intros.
rewrite H.
reflexivity.
Qed.


(** Conversion of boundeNat. *)

Program Definition boundedNatConversion
  (b1 b2 : nat)(n1:boundedNat b1)(H:b1=b2) : 
  {n2:boundedNat b2 | proj1_sig n2 = proj1_sig n1} := 
  proj1_sig n1.
Next Obligation.
  destruct n1 ; auto.
Defined.
  
(* TODO: with a coersion ? *)

Lemma boundedNatConversionEq 
  (b1 b2 : nat)(n1:boundedNat b1)(H:b1=b2) : 
  proj1_sig(proj1_sig(boundedNatConversion b1 b2 n1 H)) = proj1_sig n1.
Proof.
  auto.
Qed.


